
Foreman - Bug #23382

Editing Smart Class Parameter of type YAML creates malformed value in release 1.17.0

04/24/2018 02:58 PM - Vadim Bulst

Status: Closed   

Priority: Urgent   

Assignee: Daniel Lobato Garcia   

Category: Parameters   

Target version: 1.17.2   

Difficulty:  Fixed in Releases:  

Triaged: No Found in Releases: 1.17.0

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/5769,

https://github.com/theforeman/foreman/p

ull/5786,

https://github.com/theforeman/foreman/p

ull/5787

  

Description

When defining smart class parameter values with type YAML and submitted in GUI an Ruby error message gets prepended for each

array entry.

Defining an YAML-Array like:

---

- name: foo

  mount_point: /bar

- name: john

  mount_point: /doe

gets saved as:

- !ruby/hash:ActiveSupport::HashWithIndifferentAccess

  name: foo

  mount_point: "/bar" 

- !ruby/hash:ActiveSupport::HashWithIndifferentAccess

  name: john

  mount_point: "/doe" 

 Just a very simple example our YAML are much more complex. This error appears since the upgrade from 1.16.1 to 1.17.0.

As we need this system for production, we can leave this installation like it is for debugging purposes for a maximum of 36hours.

HOSTNAME: urzlxdeploy.rz.uni-leipzig.de

OS: redhat

RELEASE: CentOS Linux release 7.4.1708 (Core)

FOREMAN: 1.17.0

RUBY: ruby 2.0.0p648 (2015-12-16) [x86_64-linux]

PUPPET: 4.10.11

DENIALS: 0

Related issues:

Related to Foreman - Bug #23581: Upgrade to Foreman 1.17 converts YAML to JSO... Resolved

Has duplicate Foreman - Bug #23463: YAML rendering of external nodes generate... Duplicate 04/30/2018

Associated revisions

Revision d477552c - 07/08/2018 07:42 AM - Daniel Lobato Garcia
Fixes #23382 - Hashes in arrays are shown properly on ENC

When defining smart class parameter values with type YAML and submitted

in GUI an Ruby error message gets prepended for each array entry.

Defining an YAML-Array like:

---

- name: foo

mount_point: /bar

- name: john

mount_point: /doe

is shown on the ENC as:

- !ruby/hash:ActiveSupport::HashWithIndifferentAccess

name: foo

mount_point: "/bar"

- !ruby/hash:ActiveSupport::HashWithIndifferentAccess

name: john

mount_point: "/doe"

In order to avoid parsing the whole YAML or monkeypatching

HashWithIndifferentAccess the easiest workaround is to convert to

JSON then parse back to YAML

History

#1 - 04/30/2018 04:16 PM - Anonymous

- Related to Bug #23463: YAML rendering of external nodes generates incorrect data if hashes are used added

#2 - 05/05/2018 12:53 AM - Anonymous

- translation missing: en.field_release changed from 296 to 297

I think this is https://github.com/rails/rails/issues/29013 a fix was maerged to Rails 5.1 branch and will be part of Rails 5.1.7, which is not yet

released...

#3 - 05/16/2018 06:46 PM - Anonymous

Is there any quick fix? I have upgraded to 1.17.0 recently and now all my Puppet manifests fail because the hashes are malformed? Rails 5.1.7 isn't

going to be released anytime soon, so I guess we need a fix for that.

Couldn't we just revert the change that introduced this issue from 1.16.x to 1.17.0?

#4 - 05/17/2018 10:54 AM - Tomer Brisker

- translation missing: en.field_release changed from 297 to 360

Pushing out to 1.17.2, this won't be fixed in time for 1.17.1.

#5 - 05/17/2018 05:06 PM - Anonymous

Well I fixed this in the meantime by manually editing the rails file as mentioned by Michael. Can't we just provide a patched rails release via the

foreman repos?

#6 - 05/25/2018 08:19 AM - Tobias Ehrig

The fix mentioned by Henry Spanka doesnt work for me. (Debian Stretch installed via DEB Repositoy)

#7 - 05/25/2018 01:44 PM - Anonymous

@Tobias: Have you restarted foreman (Webserver) after applying the fix? Note that you also need to edit the classes again and just save the

parameters again so they are correctly stored in the database. It is not required to change them but you need to resave them.

#8 - 05/29/2018 08:23 AM - Tobias Ehrig

@Henry: Yes, I've restarted the whole box. After the fix, the array values are displayed fine - without escaped doublequotes - but the puppet agent

still failed with the exception above.

#9 - 07/03/2018 07:17 AM - Tomer Brisker

- Related to Bug #23581: Upgrade to Foreman 1.17 converts YAML to JSON Hash added
#10 - 07/04/2018 10:19 AM - Daniel Lobato Garcia

- Triaged set to No

I'm trying hard to reproduce this, but even complex hashes seem to be rendered properly. For example:

classes:

  dhcp:

    bootfiles:

      override_value:

        match: fqdn=server.example.com

        value:

          testvg:

            physical_volumes:

            - "/dev/sdb" 

            - "/dev/sdc" 

            logical_volumes:

              test1:

                size: 128M

                mountpath: "/opt/test1" 

              test2:

                size: 128M

                mountpath: "/opt/test2" 

              test3:

                size: 128M

                mountpath: "/opt/test3" 

              test4:

                size: 128M

                mountpath: "/opt/test4" 

              test5:

                size: 128M

                mountpath: "/opt/test5" 

#11 - 07/04/2018 10:21 AM - Daniel Lobato Garcia

I do see it now, with Arrays:

classes:

  dhcp:

    bootfiles:

    - !ruby/hash:ActiveSupport::HashWithIndifferentAccess

      name: foo

      mount_point: "/bar" 

    - !ruby/hash:ActiveSupport::HashWithIndifferentAccess

      name: john

      mount_point: "/doe" 

#12 - 07/04/2018 11:09 AM - Daniel Lobato Garcia

JSON.parse(@host.info.to_json).to_yaml(:line_width => -1)

- using this in hosts_controller, on the externalNodes method works well

#13 - 07/04/2018 11:20 AM - The Foreman Bot

- Status changed from New to Ready For Testing

- Assignee set to Daniel Lobato Garcia

- Pull request https://github.com/theforeman/foreman/pull/5769 added

#14 - 07/05/2018 01:05 PM - Daniel Lobato Garcia

- Related to deleted (Bug #23463: YAML rendering of external nodes generates incorrect data if hashes are used)

#15 - 07/05/2018 01:06 PM - Daniel Lobato Garcia

- Has duplicate Bug #23463: YAML rendering of external nodes generates incorrect data if hashes are used added

#16 - 07/08/2018 08:01 AM - Daniel Lobato Garcia

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset d477552ce73a703fbf9fb93e7b1539ec639607ee.
#17 - 07/09/2018 06:11 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/5786 added

#18 - 07/09/2018 06:12 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/5787 added
